#!/bin/sh
#
# installer for viwl. do not execute directly. use the Makefile instead.
# creates a config file for viwl
#

dst=$1

execute () {
  echo $*
  $*
}

umask 022


# manipulate path in the hope that we find the maximum of installed editors
PATH=$PATH:/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/usr/X11R6/bin:/opt/bin:/opt/fsf/bin:/usr/openwin/bin

EDITORS=" vi vim emacs pico joe elvis nedit nano jove xemacs gvim "
USEEDITORS=""
for dir in `echo $PATH | sed 's/:/ /g'`; do
  #echo "Checking $dir"
  for editor in $EDITORS; do
      #echo "  Checking $editor"
      if test -x "$dir/$editor"; then
          #echo "    Adding $editor"
          USEEDITORS="$USEEDITORS $dir/$editor"
          # match, remove from list
	  EDITORS=`echo "$EDITORS" | sed "s/ $editor / /"`
	  #echo "   new EDITORS: <$EDITORS>"
      fi
  done
  #echo
done

echo "The following editors will be wrapped by viwl:"
echo $USEEDITORS
echo "Hit <Return> to accept or enter your own list (incl. path): "
read USEREDITORS

if test -n "$USEREDITORS"; then
    USEEDITORS="$USEREDITORS"
fi



for ed in $USEEDITORS; do
    if test -n "$ed"; then
	if test -e "$ed.bin"; then
	    echo "$ed.bin already exists!"
        else
	    execute mv $ed $ed.bin
	    execute ln -s $dst/viwl $ed
        fi
    fi
done






if test -e "/etc/viwl.conf"; then
    echo "Default config /etc/viwl.conf exists"
    exit
fi



# create default config
cat <<EOF > /etc/viwl.conf
#
# configuration for the vi wrapper 'viwl'
#


#
# define, which version control system to use.
# possible values: rcs, cvs or none
VERSION_CONTROL="rcs"

#
# if CVS is the version control system of your choice, then
# you need to define the cvs-root here.
# run the script init-cvs.sh for creating the repository,
# the script uses /etc/viwl-CVSROOT as the CVSROOT, edit the
# script if you need to change this.
#
CVS_ROOT="/etc/viwl-CVSROOT"

#
# the workdir, which is the directory which is checked in
# and maintained with CVS. Every file will be maintained
# here in a copy.
WORK_DIR="/etc/viwl.d"

#
# define, if file backups of the form file~ should be created.
# possible values: yes, no
FILE_BACKUP="yes"

#
# viwl can handle locking for you
LOCKING="yes"

EOF


echo "You may now run init-cvs.sh if you desire to use CVS."
